/********************************** (C) COPYRIGHT *******************************
 * File Name          : main.c
 * Author             : WCH
 * Version            : V1.0.0
 * Date               : 2021/06/06
 * Description        : Main program body.
*********************************************************************************
* Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
* Attention: This software (modified or not) and binary are used for 
* microcontroller manufactured by Nanjing Qinheng Microelectronics.
*******************************************************************************/

/*
 *@Note
 USART Print debugging routine:
 USART1_Tx(PA9).
 This example demonstrates using USART1(PA9) as a print debug port output.

*/

#include "debug.h"

/* Global typedef */

/* Global define */

/* Global Variable */

void LED_Init(void)
{
    GPIO_InitTypeDef  GPIO_InitStructure={0};                //һGPIO_InitTypeDef͵Ľṹ

    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);//ʹLEDصGPIO˿ʱ

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0|GPIO_Pin_1; //GPIO
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;     //GPIOģʽΪ
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;    //GPIOٶ
    GPIO_Init(GPIOA, &GPIO_InitStructure);               //ÿ⺯ʼGPIOA

    GPIO_SetBits(GPIOA,GPIO_Pin_0|GPIO_Pin_1);           //ߵƽ
}

void TIM1_Int_Init(u16 arr,u16 psc)
{
    TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure={0};
    NVIC_InitTypeDef         NVIC_InitStructure={0};

    RCC_APB2PeriphClockCmd(RCC_APB2Periph_TIM1, ENABLE);       //ʹTIM1ʱ

    TIM_TimeBaseStructure.TIM_Period = arr;                    //ָ´θ¼ʱҪصԶ¼ؼĴеֵ
    TIM_TimeBaseStructure.TIM_Prescaler =psc;                  //ָڻTIMʱӵԤƵֵ
    TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1;    //ʱӷƵ
    TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;//TIMģʽϼģʽ
    TIM_TimeBaseStructure.TIM_RepetitionCounter = 0;
    TIM_TimeBaseInit(TIM1, &TIM_TimeBaseStructure);            //ָĲʼTIMxʱλ

    //ʼTIM NVICжȼ
    NVIC_InitStructure.NVIC_IRQChannel = TIM1_UP_IRQn;         //TIM1ж
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;  //ռȼ0
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 3;         //Ӧȼ3
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;            //ʹͨ1ж
    NVIC_Init(&NVIC_InitStructure);                            //ʼNVIC

    TIM_ITConfig(TIM1,TIM_IT_Update,ENABLE ); //ʹTIM1жϣж

    TIM_Cmd(TIM1, ENABLE); //TIM1ʹ
}

/*********************************************************************
 * @fn      main
 *
 * @brief   Main program.
 *
 * @return  none
 */
int main(void)
{
    u8 j=0;
    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
    Delay_Init();
    USART_Printf_Init(115200);

    printf("SystemClk:%d\r\n", SystemCoreClock);
    printf("This is printf example\r\n");

    LED_Init();
    TIM1_Int_Init(1000-1,96-1);

    while(1)
    {
        GPIO_WriteBit(GPIOA, GPIO_Pin_0, (j==0) ? (j=Bit_SET):(j=Bit_RESET));
        Delay_Ms(100);
    }
}

void TIM1_UP_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));
void TIM1_UP_IRQHandler(void)
{
    static u8 i=0;

    if(TIM_GetITStatus(TIM1, TIM_IT_Update) != RESET) //TIM1жǷ
    {
        TIM_ClearITPendingBit(TIM1,TIM_IT_Update);      //TIM1жϹλ
        GPIO_WriteBit(GPIOA, GPIO_Pin_1, (i==0) ? (i=Bit_SET):(i=Bit_RESET));
    }
}
